//
//  MyOpenGL.m
//  Example
//
//  Created by 川上 博 on 2015/11/12.
//  Copyright © 2015年 Hiroshi Kawakami. All rights reserved.
//

#import "MyOpenGLView.h"
#import <GLUT/glut.h>
#include <math.h>

#define DEG	M_PI/180.0

float red, green, blue;
NSColor *color;

@implementation MyOpenGLView

double unit=0.5, angle=0.0;
double currentX, currentY;
double r1, r2;

void home(void){
    angle=0.0;
    currentX=0.0;
    currentY=0.0;
}

void rot(double degree){
    angle +=degree;
}

void fwd(double length){
    double rad, xaxis, yaxis;

    rad=DEG*angle;
    xaxis=unit*length*sin(rad);
    yaxis=unit*length*cos(rad);
    glBegin(GL_LINES);
    glVertex2f(currentX, currentY);
    glVertex2f(currentX+xaxis,currentY+yaxis);
    glEnd();
    currentX=currentX+xaxis;
    currentY=currentY+yaxis;
}

void jmp(double length){
    double rad, xaxis, yaxis;

    rad=DEG*angle;
    xaxis=unit*length*sin(rad);
    yaxis=unit*length*cos(rad);
    currentX=currentX+unit*length*sin(rad);
    currentY=currentY+unit*length*cos(rad);
}

void branch(double length, int n){
    if (n==1) return;
    else {
        fwd(length);
        rot(70.0);
        branch(length/(1.5), n-1);
        rot(-90.0);
        branch(length/(1.5), n-1);
        rot(20.0);
        fwd(-length);
    }
}

static void drawAnObject(void){
    glColor3f(0.0f,1.0f,1.0f);
    glLineWidth(2.0);
    home();
    jmp(-0.5);
    fwd(-0.8);

    branch(1.0, 12);
}

- (void) drawRect:(NSRect)bounds{
    glViewport(0,0,NSWidth([self bounds]),NSHeight([self bounds]));
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    
    glClearColor(0.0,0.0,0.0,0.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    drawAnObject();
    glFlush();
}

@end
